/*
Autor  : Piotr Zielinski
Zadanie: Asteroida
*/

#include <stdio.h>
#include <math.h>

double X, Y, Z;
int n;
double ZERO=1E-10;

double VectorProduct(	double x1, double y1, double z1,
											double x2, double y2, double z2,
											double x3, double y3, double z3) {
	return x1*y2*z3 + y1*z2*x3 + x2*y3*z1 -
				 x1*y3*z2 - x2*y1*z3 - x3*y2*z1;
}

double Area( double x1, double y1, double z1,
											double x2, double y2, double z2) {
	double xx = y1*z2 - y2*z1;
	double yy = z1*x2 - x1*z2;
	double zz = x1*y2 - x2*y1;
	return sqrt(xx*xx + yy*yy + zz*zz)/2;
}

void Compute(FILE *fin, FILE *fout) {
	fscanf(fin, "%i %lf %lf %lf", &n, &X, &Y, &Z);

	double allarea=0;
	double photoarea=0;

	for(int i=0;i<n;i++) {
		double x0, y0, z0, x1, y1, z1, x2, y2, z2;
		int m;
		int visible;
		fscanf(fin, "%i %lf %lf %lf %lf %lf %lf %lf %lf %lf",
			&m, &x0, &y0, &z0, &x1, &y1, &z1, &x2, &y2, &z2);
		if (VectorProduct(x1-x0, y1-y0, z1-z0,
											x2-x0, y2-y0, z2-z0,
											X-x0, Y-y0, Z-z0) > ZERO) visible = 1;
			else visible = 0;
		int i=2;
		for(;;) {
			double area = Area(x1-x0, y1-y0, z1-z0,	x2-x0, y2-y0, z2-z0);
			allarea += area;
			if (visible) photoarea +=area;
			if (++i >= m) break;
			x1=x2;y1=y2;z1=z2;
			fscanf(fin, "%lf %lf %lf", &x2, &y2, &z2);
		}
	}
	fprintf(fout, "%.2lf\n", photoarea/allarea*100);
}

int main(void) {
	FILE *fin = fopen("asteroid.in","rt");
	FILE *fout = fopen("asteroid.out","wt");
	int d;

	fscanf(fin, "%i", &d);
	for(int i=0;i<d;i++)
		Compute(fin, fout);

	fclose(fin);
	fclose(fout);
	return 0;
}