/*
Autor  : Piotr Zielinski
Zadanie: Stronicowanie
*/

#include <stdio.h>
#include <string.h>

const int N=2000;	//max. pojemnosc pamieci
const int M=5000;  //max. pojedmosc pamieci wirtualnej
const int S=10000;	//max. dlugosc sekwencji

int pages[S];
int next[S];
int prev[M];
int (&nx)[M]=prev;

int heap[N+1];
int place[M];

int n, m, s;

void Load(FILE *fin) {
	fscanf(fin, "%i %i %i", &n, &m, &s);
	for(int i=0;i<s;i++) {
		int a;
		fscanf(fin,"%i",&a);
		pages[i]=a-1;
	}
}

void ComputeNext(void) {
	memset(prev, -1, sizeof(prev));
	for(int i=0;i<s;i++) {
		next[i]=S;
		if (prev[pages[i]]>=0) next[prev[pages[i]]] = i;
		prev[pages[i]]=i;
	}
}

void GoUp(int start=0) {
	int t = start;
	if (!t) t=heap[0];
	while (t>1) {
		int parent = t/2;
		if (nx[heap[t]] <= nx[heap[parent]]) break;
		int temp = heap[t];
		heap[t] = heap[parent];
		heap[parent] = temp;
		place[heap[t]]=t;
		t = parent;
		place[heap[t]]=t;
	}
}

void GoDown(int start=1) {
	int t=start;
	while (t<=heap[0]) {
		int son = 2*t;
		int further=0;
		if (son>heap[0]) break;
		if (son+1<=heap[0] && nx[heap[son+1]] > nx[heap[son]]) further = 1;
		if (nx[heap[t]] >= nx[heap[son + further]]) break;
		int temp = heap[t];
		heap[t] = heap[son + further];
		heap[son + further] = temp;
		place[heap[t]]=t;
		t = son + further;
		place[heap[t]]=t;
	}
}

int Simulate(void) {
	int loads=0;
	for(int i=s-1;i>=0;i--)
		nx[pages[i]]=i;
	memset(place, 0, sizeof(place));
	heap[0]=0;
	for(i=0;i<s;i++) {
		nx[pages[i]]=next[i];
//		if (place[pages[i]]>0) printf("-");
//			else printf("+");
		if (place[pages[i]]>0) {
			GoUp(place[pages[i]]);
			continue;
		}
		if (heap[0] >= n) {
			place[heap[1]]=0;
			heap[1] = heap[heap[0]--];
			GoDown();
		}

		loads++;
		heap[++heap[0]] = pages[i];
		place[pages[i]]=heap[0];
		GoUp();
	}
	return loads;
}

int main(void) {
	FILE *fin = fopen("stronic.in","rt");
	FILE *fout = fopen("stronic.out","wt");
	int d;
	fscanf(fin, "%i", &d);

	for(int i=0;i<d;i++) {
		Load(fin);
		ComputeNext();
		fprintf(fout,"%i\n",Simulate());
	}

	fclose(fin);
	fclose(fout);

	return 0;
}

