/*
Autor  : Piotr Zielinski
Zadanie: Stronicowanie
*/

#include <stdio.h>
#include <string.h>

const int N=2000;	//max. pojemnosc pamieci
const int M=5000;  //max. pojedmosc pamieci wirtualnej
const int S=10000;	//max. dlugosc sekwencji

int pages[S];
int next[S];
int prev[M];
int (&nx)[M]=prev;

int heap[N+1];
char is[M];

int n, m, s;

void Load(FILE *fin) {
	fscanf(fin, "%i %i %i", &n, &m, &s);
	for(int i=0;i<s;i++) {
		int a;
		fscanf(fin,"%i",&a);
		pages[i]=a-1;
	}
}

void ComputeNext(void) {
	memset(prev, -1, sizeof(prev));
	for(int i=0;i<s;i++) {
		next[i]=S;
		if (prev[pages[i]]>=0) next[prev[pages[i]]] = i;
		prev[pages[i]]=i;
	}
}

void GoUp(void) {
	int t = heap[0];
	while (t>1) {
		int parent = t/2;
		if (nx[heap[t]] <= nx[heap[parent]]) break;
		int temp = heap[t];
		heap[t] = heap[parent];
		heap[parent] = temp;
		t = parent;
	}
}

void GoDown(void) {
	int t=1;
	while (t<=heap[0]) {
		int son = 2*t;
		int further=0;
		if (son>heap[0]) break;
		if (son+1<=heap[0] && nx[heap[son+1]] > nx[heap[son]]) further = 1;
		if (nx[heap[t]] >= nx[heap[son + further]]) break;
		int temp = heap[t];
		heap[t] = heap[son + further];
		heap[son + further] = temp;
		t = son + further;
	}
}

int Simulate(void) {
	int loads=0;
	for(int i=s-1;i>=0;i--)
		nx[pages[i]]=i;
	memset(is, 0, sizeof(is));
	heap[0]=0;
	for(i=0;i<s;i++) {
		nx[pages[i]]=next[i];
//		if (is[pages[i]]) printf("-");
//    	else printf("+");
		if (is[pages[i]]) continue;
		if (heap[0] >= n) {
			heap[0]--;
			int max=-1, maxi;
			for(int j=0;j<m;j++)
				if (is[j] && nx[j]>max) {max=nx[j];maxi=j;}
			is[maxi]=0;
		}

		loads++;
		is[pages[i]]=1;
		heap[0]++;
	}
	return loads;
}

int main(void) {
	FILE *fin = fopen("stronic.in","rt");
	FILE *fout = fopen("stronic2.out","wt");
	int d;
	fscanf(fin, "%i", &d);

	for(int i=0;i<d;i++) {
		Load(fin);
		ComputeNext();
		fprintf(fout,"%i\n",Simulate());
//		printf("\n");
	}

	fclose(fin);
	fclose(fout);

	return 0;
}

