/*
Autor  : Piotr Zielinski
Zadanie: Patrole policyjne
*/

#include <stdio.h>
#include <string.h>

const N=100;
char isroad[N][128];

int prev[N];
int queue[N];
int qr,qw;

int n;

void BFS(int A) {
	memset(prev,-1,sizeof(prev));
	prev[A]=A;
	qr=0;qw=1;queue[0]=A;

	while (qw>qr) {
		int v = queue[qr++];
		for(int i=0;i<n;i++)
			if (isroad[v][i] && prev[i]<0) {
				prev[i]=v;
				queue[qw++]=i;
			}
	}
}

int MaxFlow(int A, int B) {
	for(int flow=0;;flow++) {
		BFS(A);
		if (prev[B]<0) break;
		int v=B;
		while (v!=A) {
			isroad[prev[v]][v]=0;
			isroad[v][prev[v]]=1;
			v=prev[v];
		}
	}
	return flow;
}

void Compute(FILE *fin, FILE *fout) {
	int m, A, B;
	fscanf(fin, "%i %i %i %i", &n, &m, &A, &B);A--;B--;
	memset(isroad, 0, sizeof(isroad));
	for(int i=0;i<m;i++) {
		int a,b;
		fscanf(fin, "%i %i", &a, &b);
		isroad[a-1][b-1]=1;
	}
	fprintf(fout, "%i\n", MaxFlow(A, B));
}

int main(void) {
	FILE *fin = fopen("patrole.in","rt");
	FILE *fout = fopen("patrole.out","wt");
	int d;

	fscanf(fin, "%i", &d);
	for(int i=0;i<d;i++)
		Compute(fin, fout);

	fclose(fin);
	fclose(fout);
	return 0;
}