/*
Autor  : Piotr Zielinski
Zadanie: Saper
*/

#include <stdio.h>
#include <string.h>

int bombs[10001];
char state[10001];		//0-nie wiem, 1 - nie ma bomby, 2 - bomba

int n, k;

int NWD(int a, int b) {
	int c;
	if (a<b) {c=a;a=b;b=c;}
	while (b>0) {c=a%b;a=b;b=c;}
	return a;
}

void UpdateState(int n, int k) {
	int nwd = NWD(n, k);

	for(int t=0;t<2;t++)
		for(int j=0;j<nwd;j++) {
			int i=j;
			do {
				int nextk=i+k;if (nextk>=n) nextk-=n;
				if (state[i]>0)
					if (bombs[i]==bombs[i+1]) state[nextk]=state[i];
						else state[nextk]=3-state[i];
				else {
					if (bombs[i]>bombs[i+1]) {state[i]=2; state[nextk]=1;}
					if (bombs[i]<bombs[i+1]) {state[i]=1; state[nextk]=2;}
				}
				i=nextk;
			} while (i!=j);
		}
}

void Compute(FILE *fin, FILE *fout) {
	fscanf(fin, "%i %i", &n, &k);

	for(int i=0;i<n;i++)
		fscanf(fin, "%i", bombs+ (i-k+n)%n);
	bombs[n]=bombs[0];

	k=2*k+1;
	memset(state,0,sizeof(state));

	UpdateState(n, k);

	int sum[3]= {0,0,0};

	for(i=0;i<k;i++)
		sum[state[i]]++;

	for(i=0;i<n;i++) {
		if (bombs[i] == sum[2]) {
			for(int j=0;j<k;j++)
				if (state[(i+j)%n]==0) state[(i+j)%n]=1;
			break;
		}
		if (bombs[i] == sum[2]+sum[0]) {
			for(int j=0;j<k;j++)
				if (state[(i+j)%n]==0) state[(i+j)%n]=2;
			break;
		}
		sum[state[i]]--;
		sum[state[(i+k)%n]]++;
	}

	UpdateState(n, k);

	for(i=0;i<n;i++)
		switch(state[i]) {
			case 0 : fputc('?',fout);break;
			case 1 : fputc('0',fout);break;
			case 2 : fputc('1',fout);break;
		}
	fputc('\n',fout);
}


int main(void) {
	FILE *fin = fopen("saper.in","rt");
	FILE *fout = fopen("saper.out","wt");
	int d;

	fscanf(fin, "%i", &d);
	for(int i=0;i<d;i++)
		Compute(fin, fout);

	fclose(fin);
	fclose(fout);
	return 0;
}